// ----------------------
// --- Layout Manager ---
// ----------------------

var EmbedLayout = function() 
{

    if( this.playerType == 'iframe' )
    {
        this.frame = document.createElement('iframe');
    }
    else
    {
        if(!app.bsMessagePort)
        {
            app.createMessagePort();
        }
    }

    return this;

};

EmbedLayout.prototype.playerType = 'iframe';

EmbedLayout.prototype.show = function( layoutName, force )
{

    // if( app.device.CMSData && app.device.CMSData.device && app.device.CMSData.device.settings && app.device.CMSData.device.settings.videoPlayer == 'native' )
    // {
    //     this.bsMessagePort.PostBSMessage( {
    //         module: 'VideoPlayer',
    //         action: 'Clear',
    //     } );
    // }

    clearTimeout(this.timeout);
    this.timeout = setTimeout(this.load.bind(this, layoutName, force), 2000);
    
};

// EmbedLayout.prototype.load = function( layoutName, force )
// {

//     if( this.currentLayout != layoutName || force )
//     {

//         this.currentLayout = layoutName;

//         if( !layoutName )
//         {

//             if( this.frame.parentNode )
//             {

//                 this.frame.parentNode.removeChild(this.frame);

//             }

//             app.domEl.app.classList.add('noContent');

//         }
//         else
//         {

//             var time = new Date().getTime();

//             this.frame.src = 'files/' + layoutName + '?bs=true&timestamp=' + time;

//             app.domEl.content.appendChild(this.frame);

//             app.domEl.app.classList.remove('noContent');

//         }

//     }

// };

// EmbedLayout.prototype.load = function(layoutName, force)
// {

//     if( this.currentLayout != layoutName || force )
//     {

//         this.currentLayout = layoutName;

//         if( !layoutName )
//         {

//             if( this.htmlwidget )
//             {

//                 this.htmlwidget.close();

//             }

//             app.domEl.app.classList.add('noContent');

//         }
//         else
//         {

//             var time = new Date().getTime();

//             if( this.htmlwidget )
//             {
//                 this.htmlwidget.close();
//             }

//             var HtmlWidgetClass = require("@brightsign/htmlwidget");
//             this.htmlwidget = new HtmlWidgetClass({ 
//                 rect: {
//                     x: 0, y:0, w: app.device.details.width, h: app.device.details.height 
//                 }, 
//                 url: "/storage/sd/files/" + layoutName,
//                 inspectorServer: "192.168.1.25:3000"
//             });

//             // app.domEl.app.classList.remove('noContent');

//         }

//     }

    
// };

EmbedLayout.prototype.load = function(layoutName, force)
{

    if( this.currentLayout != layoutName || force )
    {

        this.currentLayout = layoutName;

        if( !layoutName )
        {

            if( this.playerType == 'iframe' )
            {
                if( this.frame.parentNode )
                {

                    this.frame.parentNode.removeChild(this.frame);

                }

                app.domEl.app.classList.add('noContent');
            }
            else
            {
                app.bsMessagePort.PostBSMessage( {
                    module: 'Browser',
                    action: 'hide',
                } );
            }
            // app.domEl.app.classList.add('noContent');

        }
        else
        {

            // var time = new Date().getTime();

            // if( this.htmlwidget )
            // {
            //     this.htmlwidget.close();
            // }

            // var HtmlWidgetClass = require("@brightsign/htmlwidget");
            // this.htmlwidget = new HtmlWidgetClass({ 
            //     rect: {
            //         x: 0, y:0, w: app.device.details.width, h: app.device.details.height 
            //     }, 
            //     url: "/storage/sd/files/" + layoutName,
            //     inspectorServer: "192.168.1.25:3000"
            // });

            if( this.playerType == 'iframe' )
            {
                var time = new Date().getTime();

                var res = app.brightSign.preferredScreenMode.modeName.split('x');

                this.frame.src = 'files/' + layoutName + '?bs=true&version=2.0.7&width='+res[0]+'&height='+res[1]+'&orientation='+app.brightSign.orientation+'&fullres=' + (app.brightSign.checkFullRes() ? 'true' : 'false') + '&videoMode=' + app.brightSign.preferredScreenMode.modeName + '&timestamp=' + time;

                app.domEl.content.appendChild(this.frame);

                app.domEl.app.classList.remove('noContent');
            }
            else
            {
                app.bsMessagePort.PostBSMessage( {
                    module: 'Browser',
                    action: 'show',
                } );
            }

            // app.domEl.app.classList.remove('noContent');

        }

    }

    
};